<%@ Page Language="C#" MasterPageFile="~/main.master" Title="Untitled Page" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data" %>

<script runat="server">

    protected void Page_Load(object sender, EventArgs e)
    {
        // show exam result
        Examination exam = (Examination)Session["questions"];
        lblSubject.Text = exam.sname;
        lblStime.Text = exam.StartTime.ToString();
        TimeSpan ts = DateTime.Now.Subtract(exam.StartTime);
        lblMin.Text = ts.Minutes.ToString();
        lblNquestions.Text = exam.SIZE.ToString();
        
        // find how many correct answers
        int cnt = 0;
        foreach (Question q in exam.questions)
        {
            if (q.IsCorrect())
                cnt++;
        }

        lblNcans.Text = cnt.ToString();
        exam.ncans = cnt;
        Session.Add("questions", exam);

        if (cnt > 3)
            lblGrade.Text = "Excellent";
        else
            if (cnt > 1)
                lblGrade.Text = "Average";
            else
                lblGrade.Text = "Poor";
        // add row to OE_EXAMS table
        SqlConnection con = new SqlConnection("uid=sa;database=exam");
        con.Open();
        SqlCommand cmd = new SqlCommand("select isnull( max(examid),0) + 1 from oe_exams", con);
        int examid = (Int32) cmd.ExecuteScalar();
        cmd.CommandText = "insert into oe_exams values(@examid,@mid,@sid,@noq,@ncans,@stdate,getdate())";
        cmd.Parameters.Add("@examid", SqlDbType.Int).Value = examid;
        cmd.Parameters.Add("@mid", SqlDbType.Int).Value = exam.mid;
        cmd.Parameters.Add("@sid", SqlDbType.Int).Value = exam.sid;
        cmd.Parameters.Add("@noq", SqlDbType.Int).Value = exam.SIZE;
        cmd.Parameters.Add("@ncans", SqlDbType.Int).Value = exam.ncans;
        cmd.Parameters.Add("@stdate", SqlDbType.DateTime).Value = exam.StartTime;
        cmd.ExecuteNonQuery();
        con.Close();   
        
    }

    protected void lbRank_Click(object sender, EventArgs e)
    {

      Examination exam = (Examination)Session["questions"];
      double per =  (double) exam.ncans / exam.SIZE;
      SqlConnection con = new SqlConnection(DBUtil.ConnectionString );
      con.Open();
      SqlCommand cmd = new SqlCommand("select count(*) from oe_exams where nocans * 1.0 / noq >= @per and  sid = @sid", con);
      cmd.Parameters.Add("@per", SqlDbType.Decimal).Value = per;
      cmd.Parameters.Add("@sid", SqlDbType.Int).Value = exam.sid;
      int rank = (Int32)cmd.ExecuteScalar();

      cmd.CommandText = "select count(*) from oe_exams where sid = @sid";
      int total = (Int32) cmd.ExecuteScalar();
         
      con.Close();

      lblRank.Text = "<h4>Your Rank : " + rank.ToString() + " out of " + total.ToString() + " </h4>"; 
   
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <br />
    <h2>
    Examination Result</h2>
    &nbsp;
    <br />
    <table bgcolor="#eeeeee" border=1>
        <tr>
            <td>
                Subject:
            </td>
            <td>
                <asp:Label ID="lblSubject" runat="server" Text="Label"></asp:Label></td>
        </tr>
        <tr>
            <td>
                Starting Time :
            </td>
            <td>
                <asp:Label ID="lblStime" runat="server" Text="Label"></asp:Label></td>
        </tr>
        
        <tr>
            <td>
                Time Taken In Minutes : 
            </td>
            <td>
                <asp:Label ID="lblMin" runat="server" Text="Label"></asp:Label></td>
        </tr>
        
                <tr>
            <td>
               No. of Questions :
            </td>
            <td>
                <asp:Label ID="lblNquestions" runat="server"></asp:Label></td>
        </tr>
        
                <tr>
            <td>
                No. of correct answers :
            </td>
            <td>
                <asp:Label ID="lblNcans" runat="server" Text="Label"></asp:Label></td>
        </tr>

        <tr>
            <td>
                Grade : 
            </td>
            <td>
                <asp:Label ID="lblGrade" runat="server" Text="Label"></asp:Label></td>
        </tr>


    </table>
    <br />
    <a  href="reviewquestions.aspx">Review Questions</a>
    <asp:LinkButton ID="lbRank" runat="server" OnClick="lbRank_Click">Rank The Result</asp:LinkButton><br />
    <br />
    <asp:Label ID="lblRank" runat="server"></asp:Label><br />
    
</asp:Content>

